--Made by Peter Yu
--Project Page: https://wow.curseforge.com/projects/narcissus/files
--twitter @Peterodox

NarciSpellVisualBrowser = {};

NarciSpellVisualBrowser.Catalogue = {
    --[[
        [Category Index] = { ["name"] = Category Name,
            [Subcategory Index] = { ["name"] = Subcategory Name,
                {SpellVisualKitID,  name,  Icon FileID (optional),  Animation ID (optional),  Button Color Index (optional) },
        }
    }

        Icon: 1394890 Fel Portal
        34237
        36091 Jetpack and interesting gun
        57955 Stuff back gadget
        116750 Rainbow trail

    --]]

    [1] = {["name"] = "Minor Spells",
        [1] = { ["name"] = "Fire",
            {108320, "Pyroblast", 135808},
            {116178, "Blast", 135807},
            {16556, "Heavy", 135265},
            {101473, "Dripping", 1357810},
            {64247, "Dense small", 135839},
            {65563, "Dense medium", 135830},
            {91113, "Dense large", 237588},
            {63044, "Shining", 135810},
            {20503, "Long tail", 135815},
            {17830, "Mixed", 429384},
            {97332, "Blue", 135777},
            {64111, "Blue engulfing", 135781},
            {17758, "Dark", 425951},
            
        },

        [2] = { ["name"] = "Frost",
            {69059, "Simple Right hand", 135816},
            {68771, "Simple Left hand", 135816},
            {69384, "Shining", 1373132},
            {77214, "Shining Left hand", 1373132},
            {107260, "Jaina Cast", 236209},
            {78469, "Medium", 135864},
            {16343, "Cold blood", 135988},
            {116611, "White frost", 135849},
            {76911, "Radiant", 135851},
            {10650, "Twinkling", 609814},
            {74590, "Ice&fire", 429384},
            {75985, "Light", 463280},
            {16842, "Light Left hand", 463280},
            {113812, "Ice shard", 429385},
        },

        [3] = { ["name"] = "Light",
            {100722, "Holy fire", 535593},
            {98030, "Sphere", 632352},
            {75913, "Two orbs", 1519263},
            {43470, "Radiant", 460954},
            {107588, "Tiny", 236248},
            {108109, "Stars", 135464},
            {41004, "Solar Left", 535045},
            {41005, "Solar Right", 535045},
            {107648,"Orbiting", 1538775},
            {12481, "First aid", 135966, 63},
        },


        [4] = { ["name"] = "Shadow",
            {79554, "Large", 1022950},
            {76379, "Bright", 132851},
            {65199, "Fire&shadow", 1357804},
            {64112, "Tiny", 132843},     --long tail
            {10354, "Warlock", 136197},
            {54582, "Green", 651085},
            {15611, "Purple right", 631519},
            {10715, "Purple left", 631519},
            {10678, "Blue light", 631503},
            {96842, "Dripping Void", 1386548},
            {58009, "Void", 1728724},
            {41336, "Void dark", 1786404},
            {95630, "Medium", 237244},
            {65352, "Bright tiny", 132886},
            {95381, "Dark water", 1036179},

        },

        [5] = { ["name"] = "Arcane",
            {115446, "Bling", 1717107},
            {73948, "Sparse", 132861},
            {117171, "Orbiting", 132860},
            {12556, "Teleport", 2176537},
            {77069, "Dense", 1717106},
            {57874, "Lightning", 1033906},
            {108730, "Complex", 135869},
            {68828, "Blast", 135735},
            {97136, "Azerite", 2065562},

        },

        [6] = { ["name"] = "Fel",
            {85123, "Sphere", 1379226},
            {79791, "Fire", 135794},
            {65170, "Lightning", 463281},
            {63047, "Dense", 841218},
            {63225, "Fire&fel", 2065636},
            {25890, "Floating orbs", 1717109},
        },

        [7] = { ["name"] = "Chi",
            {107815, "Dense", 627485},
            {96448, "Lightning", 606542},
            {65215, "Mist", 627487},
            {24677, "Cloud", 1360980},
            {109599, "Sha", 651083},

        },

        [8] = { ["name"] = "Nature",
            {54442, "Emerald", 876914},
            {108131, "Regular", 136085},
            {108136, "Large", 236153},
            {77282, "Shining", 1379242},
            {100532, "Stars", 651082},
            {64834, "Water", 1698701},
            {108173, "Wind", 132837},
            {96075, "Gale", 132845},

        },

        [9] = { ["name"] = "Lightning",
            {110340, "Huge", 1370984},
            {109410, "Red", 463282},
            {103490, "Orange", 839982},
            {96590, "Small", 1117099},
            {96100, "Intense", 839977},
            {95805, "Scintillant", 136048},
            {70975, "Medium", 1385911},
            {107151, "Dark large", 135750},
        },

        [10] = { ["name"] = "Death",
            {95129, "Witchery", 2032589},
            {73426, "Nightmare 1", 1357798},
            {73112, "Nightmare 2", 1357816},
            {102960, "Blood", 1357800},
        },    
    },

    
    [2] = {["name"] = "Grand Spells",
        [1] = { ["name"] = "Frost",
            {107205, "Snow flake", 135849},
            {108283, "Glacial Ray", 135836},
            {108284, "Jaina", 1345085},
            {10252, "Conjuring", 464484},
            {112813, "Ray of frost", 1698700},
            {108124, "Elsa", 135849},
            {24397, "Frost nova", 135848},
            {10292, "Death Knight", 236205},
            {17869, "Great orbs", 343638},
            {116197, "Flash", 135837},
            {80037, "Ice barrier", 458718,},

        },

        [2] = { ["name"] = "Fire",
            {63087, "Shockwave", 236216},
            {83901, "Blast", 237582},
            {108170, "Ring", 132847},
            {65218, "Phoenix", 526578}, 
            {15631, "Rocket boots", 133029},
            {67255, "Flame cannon", 1387353},
            {103111, "Burning steps", 1339435, 143}, 
            {69530, "Dragon\'s breath", 134153, }, 
            {80292, "Blazing barrier", 132221, },
        },

        [3] = { ["name"] = "Lightning",
            {105402, "Strike down", 136050},
            {96062, "Conduit", 1370984},
        },

        [4] = { ["name"] = "Shadow",
            {92782, "Dark mist", 2065615},
            {106887, "Channeling", 1022950},
            {20896, "Shadow mourne", 463286},
        },

        [5] = { ["name"] = "Light",
            {104186, "Holy book", 133745},
            {98177, "Energy shield", 1621331},
            {106743, "Holy light", 236247},
            {84441, "Holy barrier", 236264},
            {33392, "Angelic wings", 463835},
            {60185, "Wings&stars", 608954},
            {57000, "Wings&crown", 1581161},
            {68380, "Wings&particals", 571555},
            {77556, "White Transparent", 1445239},
            {11186, "Guardian spirit", 1060983},

        },

        [6] = { ["name"] = "Nature",
            {108411, "Star swirl", 236168,},
            {104605, "Spirit eagle", 612363,},
        },

        [7] = { ["name"] = "Arcane",
            {69120, "Charged up", 839979},
            {95043, "Evocation", 136075,},   --72816
            {68661, "Teleport", 237509, 125},
            {108092, "Mana shield", 136153, },
            {108728, "Prismatic Image", 1391780},
            {80197, "Prismatic barrier", 135991},
            {116946, "Absorbing power", 1120359},
            {107247, "Azerite Abosrb", 2065618},

        },

        [8] = { ["name"] = "Hearthstone",
            {106481, "Noblegarden", 237000, 1330},
            {106582, "Midsummer", 135268, 1088},
            {106588, "Brewfest", 133697,},
        },
    },

    [3] = {["name"] = "Body&Environment",
        [1] = { ["name"] = "Color Tone",
            {118304, "Shadowland", 838686},
            {118636, "Midsummer", 133886},
            {118726, "Ghost", 236548},
            {116664, "Pale", 878223},
            {108962, "Bwonsamdi", 237586},
            {108801, "Death", 2065583},    
            {108741, "Spirit", 236288},
            {81708, "Void", 656169},
            {105476, "Tecnical", 2620862},
            {100346, "Dark purple", 917922},
            {97236, "Void remnant", 236223},
            {102957, "Hexed", 2065567},
            {112020, "Golden", 1601097},
            {108154, "Cyan", 897027},
            {110374, "White", 1391535},
            {97580, "Red", 1391537},
            {109613, "Red orange", 1817485},
            {105872, "Yellow orange", 1129414},
            {105870, "Yellow", 1391538},
            {108278, "Mustard", 1129419},
            {105862, "Green", 1391536},
            {105871, "Blue", 2902999},
            {108797, "Purple", 1122139},
            {108161, "Dark purple", 1032479},
        },

        [2] = { ["name"] = "Spells",
            {79517, "Fel eruption", 841219},
            {111150, "Ice form", 1387355, },
            {107849, "Prismatic Image", 135994},
            {69659, "Shimmer", 1033912},
            {85900, "Shapeshifting", 254857},
            {116750, "Rainbow", 461790, 662},
            {111881, "PvP Buff Arcane", 458224},
            {111880, "PvP Buff Defense", 1058940},
            {111874, "PvP Buff Nature", 614747},
            {111875, "PvP Buff Rage", 136088},
            {111876, "PvP Buff Air", 132845},     
            {59465, "Empowerment", 236295,},
            {92131, "Dread Flame", 1027878},
            {61678, "Haunted soul", 136123},
            {86037, "Tendrils High", 537022},
            {86040, "Tendrils Low", 133574},
            --{87041, "Purple contour", },
            --{96941, "Blue contour", },
            {67847, "Void Form Mild", 458229},
            --{67790, "Mild darker", 458229},
            {93175, "Transparent", 236735},
            {95872, "Fume only", 841382},
            {109405, "Channeling", 1500910},
            {102984, "Intense bright", 1022944},
            {110735, "Intense dark", 1500908},
            {86027, "Violent", 462324},
            {100707, "Madness", 1728724},
            --{114958, "Reflective", },


            --Holy
            --{69984, "Little wings",},
            --{70065, "Huge wings",},
        },


        [3] = { ["name"] = "Hit&Impact",
            {104956, "Cupid\'s hit", 236709},
            {36647, "Axe", 132409},
            {47106, "Fel blade", 924822},
            {103698, "Cleave Front", 132282},
            {97899, "Cleave Back", 132282},
            {108139, "Poisoned", 458736,},
            {43028, "Fireball Impact", 525023},
            {108168, "Ember", 514016, },
            {86686, "Ignited", 135818,},
            {92198, "Death Titan Red", 460952},
            {94562, "Death Titan Blue", 1506795},
            {112187, "Color strips", 134563},
            {112177, "Welding Condense", 2901574},
            {112178, "Welding Sparse", 2901574},
            {74104, "Column impact", 839983},  --66571
            {14468, "Chains", },
            
        },

        [4] = { ["name"] = "Environment",
            {63318, "Snow", 135850},
            {112555, "Rain", 132844},
            {24517, "Storm", 135739},
            {20972, "Bubbles", 512902},
            {98587, "Fishes", 237309},
            {111865, "Jellies", 970806},
            {96013, "Arcane", 236392},
            {53514, "Fel dust", 134389},
            {80449, "Cosmos", 645203},
            {10598, "Photo bomb", 133709},
            {110958, "Welding sparks", 574795},
            {107876, "Coin rain", 237281},
            {108176, "Smoke", 134382},
            {105367, "Filthy eruption", 840409},
            {22924, "Rose shower", 134222},
            

        },

        [5] = { ["name"] = "Background",
            {83914, "Void portal", 146632},
            {82709, "Shadow portal", 607513},
            {96643, "Arcane portal", 136039},
            {83222, "Fire portal", 135744},
            {91476, "Fire Scan", 1360762},
            {61676, "Rune Purple x4", 1323037},
            {61677, "Rune Orange x4", 1323039},
            {61679, "Rune Yellow x4", 1323038},
            {61680, "Rune Blue x4", 1323035},       
            {61682, "Rune Green x4", 1323036},     
        },

        [6] = { ["name"] = "Fireworks",
            {11212, "Low Red x2", 134273},
            {85802, "Swirl Blue", 134270},
            {85803, "Swirl Green", 134271},
            {85804, "Swirl Red", 134273},
            {85805, "Straight Blue", 135989},
            {85806, "Straight Green", 134283},
            {85807, "Straight Red", 134285},
            {85810, "Straight Yellow", 134287},
        },
    },

    [4] = {["name"] = "Back",
        [1] = { ["name"] = "Life",
            {84982, "Jade squash", 645344},
            {84989, "Pumpkin", 133981},
            {84991, "Carrot", 645341},
            {84997, "Turnip", 645346},
            {85018, "Meat", 134036},
            {22246, "Flowers", 413571},
            {23762, "Clay pot", 134514},
            {18436, "Lute", 463479},
            {16458, "Human baby", 134508},
            {16099, "Planks", 134329},
            {108095, "Anchor", 1686581},
            {101035, "Keeshan", 384458},
            {96255, "Shovel", 134435},
            {40717, "Regular torch", 135432},
            {101072, "Blue torch", 135781},
            {111733, "Naga torch", 461149},
            {96254, "Giant torch", 1379180},
            {64912, "Hoes", 134710},
            {15665, "Pillow", 133611},
            {40385, "Grain", 134915},
            {106391, "Umbra Crescent", 459044},
            {97033, "Charged crossbow", 305839, 48},
            {15786, "Classic totems", 132318},
            {59934, "Totem 1", 134920},
            {60173, "Totem 2", 135462},   
            {60621, "Totem 3", 310733},
            {59530, "Totem 4", 1322282},

        },

        [2] = { ["name"] = "Wings",
            {79375, "Fel", 236293},
            {37269, "Fel small", 236293},
            {25145, "Purple", 136172},
            {62682, "Bat1", 2103883, 1050},
            {22347, "Bat2", 2103881, 1050},
            {55784, "Blazing", 514340},
            {16834, "Spirit healer", 237542},
            {18381, "Angel", 463835},
            {18380, "Shadow", 1445237},
            {56580, "Archangle", 2103871},
            {51642, "Holy huge", 458225},  --huge
            {43389, "Paladin1", 571555},
            {43390, "Paladin2", 589117},
            {23129, "Paladin3", 1060982},
            {24508, "Aviana", 2103867},
            {58254, "Warlock", 136172},
            {26195, "Wild charge", 132916},   --bird 33916 42894
            {73879, "Naaru", 1100172},
        },

        [3] = { ["name"] = "Backpacks",
            {96011, "Parachute", 348519},
            {21677, "Parachute small", 1519432},
            {57651, "Explorer", 133628},
            {83511, "Archaeologist", 441139},
            {16078, "Suitcase", 644388},
            {47509, "Regular", 348526},
            {17025, "Booze & bomb", 132805},
            {53624, "Pipes", 133026},
            {59410, "Bamboo slips", 2178528},



        },

        [4] = { ["name"] = "Quivers",
            {15932, "Classic", 134410},
            {37437, "Classic askew", 134409},
            {26471, "Pandaren", 134401},
            {25141, "Pandaren waist", 134402},
        },

        [5] = { ["name"] = "Canisters",
            {117882, "Anti-gravity Pack", 465876},
            {64622, "Plague", 136016},
            {19060, "Dark liquid", 576309},
            {18569, "Water tank", 136016},
            {17913, "Coolant", 237032},
            {14242, "Purple", 576312},
            {30647, "Gnomecopter", 132241},
            {30976, "Brown tank", 1131085},
            {31371, "Green tank", 1385240},
            {58652, "Blue tank", 1020363},
            {86661, "Scrolls", 133018},
        },

        [6] = { ["name"] = "Kegs",
            {31528, "Brewmaster small", 635469},
            {31531, "Brewmaster", 635469},
            {28911, "Brewers 1", 644378},
            {28951, "Brewers 2", 644378},
            {31356, "Simple", 132623},
        },

        [7] = { ["name"] = "Explosives",
            {95905, "Arsenal", 133715},
            {111698, "Jetpack1", 511727},
            {97472, "Jetpack2", 132262},
            {105628, "Bag of bombs", 133710},
            {42711, "Ultra-safe bomb bag", 133710},   
            {16796, "Time bomb", 132995},
            {36096, "Rocket cache", 133032},
            {37687, "Powder barrel", 132620},
            {47214, "Bomb bundle", 1035047},
            {47367, "Explosive barrel", 252176},
            {39502, "Ooze barrel", 1129414},
            {47550, "Plague barrel", 517111},
            {97144, "Rocket bundle", 132262},
            {110512, "Missile", 1141394},
            --{, "", },
            --{, "", },
        },

        [8] = { ["name"] = "Banners",
            {111561, "Jolly Roger", 603532},
            {104167, "Alliance", 132486},
            {105275, "Horde", 132485},
            {96022, "Vulpera", 2057295},
            {24315, "Shado-Pan", 255135},
            {19412, "Green", 604449},
            {117204, "Battleground Horde", 255132},
            {42452, "Battleground Alliance", 255130},   --19339
            {16139, "Horde long", 461792},
            {13822, "Clan", 878249},
            {28141, "Kul'Tiras", 2261243},
            {42415, "Iron Horde", 1060987},
            {47693, "Warsong", 1001628},
            {12424, "Tourney: Human 1", 255130},
            {12425, "Tourney: Human 2", 255130},
            {12426, "Tourney: Human 3", 255130},
            {12451, "Tourney: Orc 1", 255132},
            {12452, "Tourney: Orc 2", 255132},
            {12453, "Tourney: Orc 3", 255132},
            {12436, "Tourney: NE 1", 255131},
            {12437, "Tourney: NE 2", 255131},
            {12438, "Tourney: NE 3", 255131},
            {12448, "Tourney: Forsaken 1", 255133},
            {12449, "Tourney: Forsaken 2", 255133},
            {12450, "Tourney: Forsaken 3", 255133},
            {12433, "Tourney: BE 1", 255126},
            {12434, "Tourney: BE 2", 255126},
            {12435, "Tourney: BE 3", 255126},
            {12442, "Tourney: Draenei 1", 255127},
            {12443, "Tourney: Draenei 2", 255127},
            {12444, "Tourney: Draenei 3", 255127},
            {12427, "Tourney: Gnome 1", 255129},
            {12428, "Tourney: Gnome 2", 255129},
            {12429, "Tourney: Gnome 3", 255129},
            {12430, "Tourney: Troll 1", 255135},
            {12431, "Tourney: Troll 2", 255135},
            {12432, "Tourney: Troll 3", 255135},
            {12445, "Tourney: Dwarf 1", 255128},
            {12446, "Tourney: Dwarf 2", 255128},
            {12447, "Tourney: Dwarf 3", 255128},
            {12454, "Tourney: Tauren 1", 255134},
            {12455, "Tourney: Tauren 2", 255134},
            {12456, "Tourney: Tauren 3", 255134},
            {12483, "Tourney: Argent 1", 236689},
            {12461, "Tourney: Argent 2", 236689},
            {12462, "Tourney: Argent 3", 236689}, 
            {12484, "Tourney: Ebon 1", 135309},
            {12485, "Tourney: Ebon 2", 135309},
            {12486, "Tourney: Ebon 3", 135309},      
            --{, "", },
            --{, "", },

        },
    },

    [5] = {["name"] = "Head",
        [1] = { ["name"] = "Pepes",
            {52838, "Original", 1044996},
            {57227, "Pirate", 2055034},
            {57228, "Knight", 133833},
            {57229, "Ninja", 133143},
            {57230, "Viking", 669453},
            {59131, "Scarecrow", 1337422},
            {72523, "Traveler", 3056991},
            {82672, "Demon Hunter", 1612573},
            {100924, "Diver", 133151},
            {100671, "Zandalari", 1729380},
            {115987, "Robotic", 1041266},
            {122909, "Winter Veil", 1339669},    --8.3
            {78648, "Feathers", 1108079},
        },

        [2] = { ["name"] = "Hat&Masks",
            {105420, "Irontide hat", 2055038, },
            {109381, "Witch hat&glasses", 1337422, },
            {10682, "Voodoo 1", 133067},
            {10683, "Voodoo 2", 133097},
            {10684, "Voodoo 3", 135111},
            {103329, "Charcoals", 135262},

        },

        [3] = { ["name"] = "Mouth",
            {58897, "Candy cane", 134017,},
            {13739, "Drunken bubbles", 136148},
            {12933, "Bubblegum", 133998},
            {8000, "Cold breath", 135864},
            {48706, "Acid breath", 132104, 14},
            {33014, "Acid cloud breath", 988195, 14},    --5x Bigger 48532   faster 24293
            {8353, "Drunken vomit", 575589, 14},    
            {37119, "Flame breath Fel", 135798, 55},
            {15317, "Flame breath Blue", 135781, 55},
            {29879, "Frost breath", 136007, 55},


        },

        [4] = { ["name"] = "Misc",
            {103482, "Love 1 High", 135451},
            {63837, "Love 1 Low", 135451},
            {103007, "Love 2", 135454},
            {65198, "Single orb", 132839},
            {78597, "Flame orbs", 132839}, 
            {109111, "Bowknot", 133801},
            {15479, "Doll Blue", 134506},
            {15480, "Doll Beige", 134505},
            {42352, "Exclamation Mark", 236666},
            {96646, "Bubble", 462651},
            {18823, "Bucket head", 1063279},
            {91304, "ZZzzz", 136090},
            {62786, "Hunter's mark", 236188},
            {70954, "Dazzled", 135860, 1160},   --stun
        },

    },

    [6] = {["name"] = "Gadgets",
        [1] = { ["name"] = "Artifact",
            {118574, "Heart Dimmed", 1869493, 1330},
            {104534, "Heart Glowing 1 ", 1869493, 1330},
            {111178, "Heart Glowing 2", 1869493, 1330},
            {105146, "Synchronous Thread", 2490714, 968},
            {109729, "Ub3r-Spanner", 2735955, },
            {110840, "Silas\' Sphere", 2356035, 124},
            {105663, "Iwen\'s Rod", 2440573, },
            {110238, "Khaz\'gorian Hammer", 1278389, 136},
            {110555, "Quill of Lana\'thel", 2356068},
            {110586, "Mallet of Skins", 133053, 136},
            {109800, "Jewel Focus", 2531330, },
            {112389, "Mmmrrglllm", 2175564, },
            {6537, "Cupid\'s Bow", 135494, 109},
            {104955, "Cupid\'s Arrow", 249172, 109},
            {98038, "Hearthstone", 134414, 1330},
            {106874, "Drust runestone", 134425, 1330},
            {110786, "Energy cell", 2902386, 944},
            {88733, "Fel shard", 1135365, 1330},
            {84358, "Void crystal", 132776, 124},

        },

        [2] = { ["name"] = "Food&Drinks",
            {103172, "Small cup", 132819},
            {97468, "Medium cup", 132817},
            {75144, "Coffee", 132802},
            {96735, "Beer&bubbles", 132797, 1154},
            {81772, "Dark Iron", 132790, 1160},
            {16637, "Stein", 132800},
            {84904, "Lager Wood", 132792},
            {91528, "Lager Steel", 135999},
            {91523, "Brewfest", 133201},
            {103769, "Glass of wine", 132809},
            {16938, "Green bottle", 463860},
            {105763, "Brown bottle", 461802},
            {103486, "Gourd bottle", 132813, },
            {22050, "Tiny keg", 132622},
            {115629, "Cheese!", 133943, 1330},
            {104405, "Bread", 133950, },
            {80175, "Chicken leg", 133974, 76},
            {90955, "Steak", 134026},
            {86662, "Apple", 133976, },
            {86949, "Giant apple", 133975, },
            {18628, "Spotted egg", 132833, 1330},
            {87215, "Plate Pastries", 237357, 604},
            {103772, "Plate Alcohol", 132798, 604},
            {113053, "Plate Brewfest", 133196, 604},
            {66891, "Plate Dessert ", 237359, 604},
            {70143, "Palte Wine", 305294, 604},
            {70138, "Plate Mana wine", 463534, 592},
            {66899, "Plate Fruit", 134013, 778},
        },

        [3] = { ["name"] = "Books&Scrolls",
            {98431, "Tome", 133741, 1330},
            {92244, "Pink book", 133735, 520},
            {112064, "Blueprint", 2915721, 520},
            {44941, "Book&quill", 2103842, },
            {78057, "Book&wand", 135466, },
            {105389, "Treasure map", 1064187, 520},
            {22907, "Route map 1", 134269, 520},
            {29521, "Route map 2", 237386, 520},
            {65487, "Mail", 133468,},
            {84673, "Scroll&Bell", 133706, 1308},
            {103443, "Scroll&fish", 350650, 1306},
            {116079, "Scroll Boralus", 1500878, 1306},
            {101070, "Scroll", 1500861},
            {63123, "Parchment letter", 237446},

        }, 

        [4] = {["name"] = "Vials",
            {110953 , "Vial Small", 134864, 61},
            {87130, "Vial Huge", 134870, 63},
            {95839, "Vial Blue", 609893, 61},
            {76989, "Vial Pointed", 463921, 61},
            {87049 , "Flask Blue", 134853, 63},
            {75563, "Flask Pink", 134810, 61},
            {19530, "Blue dye", 134715, 61},
            {16695, "Orange dye", 967520, 61},
            {14001, "Huge Conical", 134748, 63},

    
        },

        [5] = { ["name"] = "Life",
            {100265, "Kettle", 1056365},
            {100264, "Kettle Watering", 607527},
            {65731, "Wooden rulers", 135437},
            {63794, "Palm leaves", 134190},
            {84366, "Giant sack", 133640},
            {108949, "Paint brush", 1387616},
            {103793, "Hand anchor", 1914118},
            {103221, "\"Football\"", 660531},
            {63405, "Torch", 135433, 1242},
            {42381, "Flowers", 348548},
            {42718, "Bushes", 134322},
            {84515, "Paddle", 135145, 1238},
            {65311, "Skull", 237272},
            {19946, "Stone hammer", 1001623},
            {91941, "Hammer&nail", 986493},
            {18154, "Shovel", 1059121},
            {99760, "Broom", 655994},
            {107901, "Buck&brush", 132806, 1272},
            {16859, "Barrel 1", 132620, 1284},
            {16551, "Barrel 2", 132622},
            {16558, "Plank", 135435},
            {15795, "Anemometer", 986487, 966},
            {15679, "Rock", 135234}, --?
            {15612, "Sack on a stick", 133942},
            {72376, "Spyglass long", 134440},
            {98315, "Spyglass short", 134441},
            {118638, "Butterfly net", 2124986, 1076},
            {116212, "Fork&Arrow", 2735993},
            {92387, "Bell", 1769027},
            {96562, "Cart of cabbage", 645343, 1216},
            {97540, "Stork", 646586, 63},
            {99496, "Strongbox", 1001977, 1208},
            {103153, "Grain bags", 133622, 1284},
            {105997, "Steel plates", 133233, 1208},
            {108586, "Horned helmet", 353520, 1242},

        },

        [6] = { ["name"] = "Weapons&Bombs",
            {100356, "Azerite-infused bomb", 2967107, },
            {91220, "Two grenades", 330082, },
            {112523, "Rocket launcher", 133032, 48},
            {99231, "Flame thrower", 304333, 48},
            {86004, "Plague sprayer", 136212, 110},
            {56885, "Purple sprayer", 1121021, 110},
            {16798, "Orange sprayer", 1121020, 110},
            {15780, "Oil sprayer", 252178, 110},
            {96446, "Kultiras rifle", 1773651, 1076},
            {97716, "Crystal-shot Longrifle", 983197, 48},
            {103360, "Paladin hammer", 613955},
            {108753, "Emerald Dagger", 1720214},
            {24657, "Ninja dart", 135431},

        },
        
        [7] = { ["name"] = "Arrows&Gunfires",
            {72393, "Brown", 133579},
            {36751, "Flaming arrowhead", 135825},
            {93815, "Windrunner", 1392555},
            {96303, "Gunfire 1", 236216},  --96371
            {96385, "Gunfire 2", 236216},
            {96328, "Dispersive", 615339},
            {96373, "Charge and fire", 2175503},
            {96375, "Lightning strike", 252174},
            {96376, "Sonic shockwave", 252188},
            {96378, "Pulse", 135780},
            {96386, "Fel", 135797},
            {99028, "Energy Blue", 135781},
            {99031, "Energy Red", 1357794},
            {112945, "Sparkle", 135839},
            {96382, "Smoke", 458733},
        },

        [8] = { ["name"] = "Transportation",
            {85847, "Fel disc", 1508512},
            {110349, "Frost disc", 574567, 120},
            {79390, "Forsaken boat", 255133},
            {79389, "Plain boat", 643416},
            {79391, "Alliance boat", 2199765},
            {102839, "Surfing boat", 517162},
            {102843, "Raft with sail", 1126431},
            {102845, "Small raft", 774121},
            {102855, "Padaren boat", 645352, 102},
            {102852, "Tribal boat", 651137, 102},
            {102862, "Elvish boat", 1527090, 102},
            
        },
    },
}

local function BuildIconSearchingTable()
    local output = {};
    local subtable, deeptable, elements = {}, {}, {};
    local Catalogue = NarciSpellVisualBrowser.Catalogue;
    local sum = 0;
    for i = 1, #Catalogue do
        subtable = Catalogue[i];
        for j = 1, #subtable do
            deeptable = subtable[j];
            if deeptable then
                for k = 1, #deeptable do
                    elements = deeptable[k];
                    output[ elements[1] ] = { elements[2], elements[3], elements[4] };      --[ID ] = {name, icon fileID, animation ID}
                    sum = sum + 1;

                    --Icon Check
                    --[[
                    if not elements[3] or elements[3] == 1 then
                        print("Icon Missing: #"..elements[1]);
                    end
                    --]]
                end
            end
        end
    end
    --print(NARCI_GRADIENT.." Spells in Collection: "..sum)
    return output;
end

local IconSearchTable = BuildIconSearchingTable();

function Narci_GetSpellVisualKitInfo(id)
    local info = IconSearchTable[id];
    --print(id)
    if info then
        --print("Found match")
        return info[1], info[2], info[3];   --name, icon fileID, animation ID
    else
        --print("No match")
        return "", 134400;                  --Question Icon
    end
end